<?php 
$colours = array('007AFF','FF7000','FF7000','15E25F','CFC700','CFC700','CF1100','CF00BE','F00');
$user_colour = array_rand($colours);
?>

<!DOCTYPE html>
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1">
<style type="text/css">

	.panel{
		margin-right: 3px;
	}

	.button {
		background-color: #4CAF50;
		border: none;
		color: white;
		margin-right:auto;  
		margin-left:auto;
		text-decoration: none;
		display: block;
		font-size: 16px;
		cursor: pointer;
		width:100%;
		height:40px;
		margin-top: 5px;
	}
	
	input[type=text]{
		width:100%;
		margin-top:5px;
	}

	.chat_wrapper {
		width: 40%;
		height:350px;
		margin-right: auto;
		margin-left: auto;
		background: #3B5998;
		border: 1px solid #999999;
		padding: 10px;
		font: 14px 'lucida grande',tahoma,verdana,arial,sans-serif;
	}
	
	.chat_wrapper .message_box {
		background: #F7F7F7;
		height:350px;
		overflow: auto;
		padding: 10px 10px 20px 10px;
		border: 1px solid #999999;
	}
	
	.chat_wrapper input{
		//padding: 2px 2px 2px 5px;
	}
	
	.system_msg{color: #BDBDBD;font-style: italic;}
	.user_name{font-weight:bold;}
	.user_message{color: #88B6E0;}

	@media only screen and (max-width: 720px) {
		/* For mobile phones: */
		.chat_wrapper {
		width: 95%;
		height: 40%;
	}

</style>
</head>
<body>	

<script src="jquery-3.1.1.js"></script>


<script >  
$(document).ready(function(){
	// create a new WebSocket object.
	// TODO: you will replace my URL with your own
	var wsUri = "ws://mmog.pbmcube.net:29820/demo/server.php"; 	
	
	//tell the browser to create the WebSocket object
	websocket = new WebSocket(wsUri); 
	
	//
	//============================
	// 4 WebSocket Protocol Msg
	//============================
	websocket.onopen = function(ev) { 
		// connection is open and notify the user
		$('#message_box').append("<div class=\"system_msg\">Connected!</div>");
	}

	//RX Message from server ...
	websocket.onmessage = function(ev) {
		var msg = JSON.parse(ev.data);	//PHP sends Json data
		var type = msg.type;			//message type
		var umsg = msg.message;			//message text
		var uname = msg.name;			//user name
		var ucolor = msg.color;			//color

		if(type == 'usermsg') {
			$('#message_box').append("<div><span class=\"user_name\" style=\"color:#"+ucolor+"\">"+uname+"</span> : <span class=\"user_message\">"+umsg+"</span></div>");
		}
		
		if(type == 'system'){
			$('#message_box').append("<div class=\"system_msg\">"+umsg+"</div>");
		}
		
		//reset text display for new content
		$('#message').val(''); 
		
		var objDiv = document.getElementById("message_box");
		objDiv.scrollTop = objDiv.scrollHeight;
		
	};
	
	websocket.onerror	= function(ev){$('#message_box').append("<div class=\"system_error\">Error Occurred - "+ev.data+"</div>");};
	
	websocket.onclose 	= function(ev){$('#message_box').append("<div class=\"system_msg\">Connection Closed</div>");}; 
	//============================
	// End of WebSocket Protocol
	//============================
	
	//============================
	// Msg Processing follows:
	//============================
	$('#send-btn').click(function(){ 
		//use clicks message send button	
		var mymessage = $('#message').val();//get message text
		var myname = $('#name').val(); 		//get user name
		
		if(myname == ""){ 
			// input validation; empty name?
			alert("Enter your Name please!");
			return;
		}
		
		if(mymessage == ""){ 
			// input validation; empty message?
			alert("Enter Some message Please!");
			return;
		}
		
		document.getElementById("name").style.visibility = "hidden";
		
		//create msg text display
		var objDiv = document.getElementById("message_box");
		
		// adjust dialog text box based on content
		objDiv.scrollTop = objDiv.scrollHeight;
		
		//prepare json data
		var msg = {
			name: myname,
			message: mymessage,
			// NOTICE: middleware interacting with data
			// This is a typical Express.js process
			color : '<?php echo $colours[$user_colour]; ?>'
		};
		
		//serialize and transmit data to MMoG App Server
		websocket.send(JSON.stringify(msg));
	});
	
});

</script>
<div class="chat_wrapper">
<div class="message_box" id="message_box"></div>
<div class="panel">
	<input 
		type="text" 
		name="name" 
		id="name" 
		placeholder="Your Name" 
		maxlength="15" 
	/>

	<input 
		type="text" 
		name="message" 
		id="message" 
		placeholder="Message" 
		maxlength="80" 
		onkeydown = 
		"if (event.keyCode == 13)document.getElementById('send-btn').click()"  
	/>

</div>

<button id="send-btn" class=button>Send</button>

</div>

</body>
</html>